class rubberBandLabel ( QLabel ) :
	def __init__ ( self, parent = None ) :
		QLabel . __init__ ( self, parent )

		self . rubberBand = QRubberBand ( QRubberBand . Rectangle, self )
		self . rubberBand . setGeometry ( QRect () )
		self . rubberBand . show ()

		self . rubberBandWindowGeo = QRect ()
		self . center = QPoint ()
		self . tweakingRubberBand = False
		self . rbx = self . rby = self . rbw = self . rbh = 0

	def mousePressEvent ( self, event ) :
		pt = self . mapFromGlobal ( event . globalPos () )

		if self . hasRubberBand () :
			rg = self . rubberBand . geometry ()
			tl, tr, bl, br = rg . topLeft (), rg . topRight (), rg . bottomLeft (), rg . bottomRight ()
			s = 5
			off, offx, offy = QPoint ( s, s ), QPoint ( s + 1, -s ), QPoint ( -s, s + 1 )

			boxes = {
				( "topLeft"     , Qt . SizeFDiagCursor ) : QRect ( tl - off , tl + off  ),
				( "topRight"    , Qt . SizeBDiagCursor ) : QRect ( tr - off , tr + off  ),
				( "bottomLeft"  , Qt . SizeBDiagCursor ) : QRect ( bl - off , bl + off  ),
				( "bottomRight" , Qt . SizeFDiagCursor ) : QRect ( br - off , br + off  ),
				( "top"         , Qt . SizeVerCursor   ) : QRect ( tl + offx, tr - offx ),
				( "bottom"      , Qt . SizeVerCursor   ) : QRect ( bl + offx, br - offx ),
				( "left"        , Qt . SizeHorCursor   ) : QRect ( tl + offy, bl - offy ),
				( "right"       , Qt . SizeHorCursor   ) : QRect ( tr + offy, br - offy )
				}

			for k, v in boxes . iteritems () :
				if v . contains ( pt ) :
					self . rbx1, self . rby1, self . rbx2, self . rby2 = rg . x (), rg . y (), rg . x () + rg . width (), rg . y () + rg . height ()
					self . tweakingPart = k [ 0 ]
					self . setCursor ( k [ 1 ] )
					self . tweakingRubberBand = True
					return

		self . rbOrigin = pt
		self . rubberBand . setGeometry ( QRect ( self . rbOrigin, QSize () ) )

	def mouseMoveEvent ( self, event ) :
		pt = self . mapFromGlobal ( event . globalPos () )
		if self . tweakingRubberBand :
			tp = self . tweakingPart
			if   tp == "topLeft"     : self . rbx1, self . rby1 = pt . x (), pt . y ()
			elif tp == "topRight"    : self . rbx2, self . rby1 = pt . x (), pt . y ()
			elif tp == "bottomLeft"  : self . rbx1, self . rby2 = pt . x (), pt . y ()
			elif tp == "bottomRight" : self . rbx2, self . rby2 = pt . x (), pt . y ()
			elif tp == "top"         : self . rby1 = pt . y ()
			elif tp == "bottom"      : self . rby2 = pt . y ()
			elif tp == "left"        : self . rbx1 = pt . x ()
			elif tp == "right"       : self . rbx2 = pt . x ()
			self . rubberBand . setGeometry ( self . rbx1, self . rby1, self . rbx2 - self . rbx1, self . rby2 - self . rby1 )
		else :
			self . rubberBand . setGeometry ( QRect ( self . rbOrigin, pt ) . normalized () )

	def mouseReleaseEvent ( self, event ) :
		self . tweakingPart = ""
		self . tweakingRubberBand = False
		self . unsetCursor ()
		if self . hasRubberBand () :
			self . correctRubberBand ()
			self . emit ( SIGNAL ( "rubberBandCreated ()" ) )
		else :
			self . emit ( SIGNAL ( "rubberBandDestroyed ()" ) )

	def hasRubberBand ( self ) :
		return self . rubberBand . geometry () . isValid ()

	def correctRubberBand ( self ) :
		rubberInLabelGlobalGeo = toGlobal ( self . rubberBand . geometry (), self ) & toGlobal ( self . geometry (), self . parent () )
		self . rubberBandWindowGeo = fromGlobal ( rubberInLabelGlobalGeo, self . parent () ) # self . parent () == form
		self . rubberBand . setGeometry ( fromGlobal ( rubberInLabelGlobalGeo , self ) )
		return rubberInLabelGlobalGeo

	def restoreRubberBand ( self ) :
		self . rubberBand . setGeometry ( fromWindow ( self . rubberBandWindowGeo, self, self . parent () ) )

	def removeRubberBand ( self ) :
		self . rubberBand . setGeometry ( QRect () )
		self . emit ( SIGNAL ( "rubberBandDestroyed ()" ) )

